# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# Action générique
#
#
###########################################################################
from twisted.python import log
from ead2.backend.lib.action import * # import des actions  et types
from ead2.backend.actions import tools

class NEW(Action):
    """ Page """
    user_description = Dict(default={}, doc="description de l'éxécutant", keys=['ip', 'name', 'role'])
    name = "<nom de l'action>" #celui de perm_nomdumodule.ini
    libelle = "Libellé de l'action dans le menu "
    category = "chemin de l'action dans le menu"
    description = "une description de l'action (affiché au survol dans le menu)"

    request = Dict(default={}, doc="arguments de la requete en cours cote frontend",
                        keys=['server', 'action'])#server et action sont les clés systématiques

    form_result = Dict(default={}, doc='retour de formulaire', keys=[clés de formulaire autorisées])

    def execute(self):
        params, self.server_nb = tools.get_request(self.request)
        # Dans le cas d'un formulaire:
        if self.form_result.has_key('cléduformulaire'):
            try:
                # formatage de données pour traitement
                resultat = tools.format_form_result(self.form_result['cléduformulaire'])
                # datas: dico utilisé pour la templatisation
                datas = self.valid_form(resultat)
            except Exception, message:
                #si il y a une erreur soulevée par nos soins, on renvoie le message
                datas = dict(message=message.message)
            # Important: on vide le formulaire
            self.form_result = {}
            return self.send_frag(datas, template='NEW',
                                templates=[nom des widgets renseignés dans 'NEW.tmpl'])

        result = {} # variable renvoyée utilisée dans le template associé
        return self.send_all(result, template='NEW',
                            templates=[nom des widgets renseignés dans 'NEW.tmpl'])

    def valid(self, resultat):
        # on traite le resultat (execution d'une action ...)
        print resultat
        ...
        if not ...:
            raise Exception , "Mon message d'erreur qui sera affiché"
        # on pourrait renvoyer des données plutôt qu'un message
        return dict(message="Le message de retour")
