#*-*coding:utf-8*-*
""" gestion des formulaires des règles de pare-feu """
from twisted.python import log
from amon.era import regles
from ead2.backend.actions import tools
from ead2.backend.actions.amon import amon_tools

zone_indices = {'admin':0,
                'pedago':1}

def get_regles_form(zone):
    rules = regles.load(zone_indices[zone])
    checkboxes = []
    for rule in rules:
        actif = {'name': rule['desc'], 'value':'actif'}
        inactif = {'name': rule['desc'], 'value':'inactif'}
        if rule['val'] == '1':
            inactif['checked'] = 'true'
        else:
            actif['checked'] = 'true'
        checkboxes.append({'libelle':rule['desc'],
                      'actif':actif,
                      'inactif': inactif})
    return dict(entete="Activez/Désactivez des règles optionnelles",
                rules=checkboxes)

def get_validate_btn(server_nb, name):
    """ renvoie la description du bouton valider """
    href = tools.make_form_link(server_nb, name, True, ['mod_regles'], 'div_msg')
    title = "Modifier les règles optionnelles du pare-feu"
    icone = "/image/ok.gif"
    libelle = "Valider"
    return dict(validate=dict(href=href,
                              title=title,
                              icone=icone,
                              libelle=libelle))

def mod_regles(zone, resultat):
    """
        valide la modification des règles optionnelles du pare-feu
        resultat : liste de regles de la forme:
            {nom de la règle:inactif/actif}
            transforme pour era:
                inactif -> 1
                actif -> 3
    """
    rules = regles.load(zone_indices[zone])
    message = "Modification des règles optionnelles :\\n"
    for rule in rules:
        if resultat.has_key(rule['desc']):
            if resultat[rule['desc']] == 'actif':
                if rule['val'] != '3':
                    rule['val'] = '3'
                    message += "   - La règle %s a été activée\\n"%rule['desc']
            else:
                if rule['val'] != '1':
                    rule['val'] = '1'
                    message += "   - La règle %s a été désactivée\\n"%rule['desc']
    regles.save(zone_indices[zone], rules)
    if amon_tools.bastion_restart():
        message += "Le pare-feu a été redémarré."
    else:
        message += "Erreur au redémarrage du pare-feu."
    return dict(message=message)
