# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
#
###########################################################################
from twisted.python import log
from ead2.backend.lib.action import * # import des actions et des types
from ead2.backend.actions import tools
import ead2.backend.actions.amon.amon_tools as t #fonctions de gestion des utilisateurs, postes....
from ead2.backend.actions.amon import user

import traceback

used_templates = ['main','form', 'formselect', 'accordion']


class Userpedago(Action):
    """
        interface de gestion des utilisateurs
        sur l'instance 1 de dansguardian
    """
    user_description = Dict(default={}, doc="description de l'éxécutant", keys=['ip', 'name', 'role'])
    name = 'user_pedago'
    libelle = 'Utilisateurs'
    description = "Gestion des utilisateurs sur la zone de configuration 2"
    category = "Configuration 2"
    request = Dict(default={}, doc="arguments de la requete en cours cote frontend",
                    keys=['server', 'action', 'todel', 'policy', 'user'])
    form_result = Dict(default={}, doc="retour formulaire de la requete en cours coté frontend",
                        keys = ['create_user'])

    def execute(self):
        """ renvoit les données pour la mise en forme
        """
        params, self.server_nb = tools.get_request(self.request)
        if self.form_result.has_key('create_user'):
            try:
                log.msg("++++ user_pedago.py : Ajout d'une référence à un utilisateur.")
                datas = user.add_user('pedago', tools.format_form_result(self.form_result['create_user']))
                datas['toexec'] = tools.make_js_link(self.server_nb, self.name, confirm=True)
            except Exception, msg:
                print dir(msg)
                traceback.print_exc()
                datas = dict(message=msg.message)
            self.form_result = {}
            return self.send_frag(datas, template='amon_user',
                                         templates=used_templates)

        elif params.has_key('policy'):
            if params.has_key('user'):
                u = params['user'][0]
                policy = params['policy'][0]
                try:
                    log.msg("++++ user_pedago.py : Modification de la politique de filtrage de %s."%u)
                    datas = user.mod_user('pedago', policy, u)
                    datas['toexec'] = tools.make_js_link(self.server_nb, self.name, confirm=True)
                except Exception, msg:
                    traceback.print_exc()
                    datas = dict(message=msg.message)
                self.form_result = {}
                return self.send_frag(datas, template='amon_user',
                                             templates=used_templates)
        elif params.has_key('todel'):
            u = params['todel'][0]
            try:
                log.msg("++++ user_pedago.py : Suppression de la référence à %s."%u)
                datas = user.del_user('pedago', u)
                datas['toexec'] = tools.make_js_link(self.server_nb, self.name, confirm=True)
            except Exception, msg:
                traceback.print_exc()
                datas = dict(message=msg.message)
            self.form_result = {}
            return self.send_frag(datas, template='amon_user',
                                         templates=used_templates)

        result = {'titre': self.description}
        result.update(user.add_form('pedago'))
        result.update(user.get_list('pedago', self.server_nb, self.name))
        result['validate'] = user.get_validate(self.server_nb, self.name)
        return self.send_all(result, template='amon_user',
                                     templates=used_templates)
