# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# Action scribe_extraction
# outil d'extraction sconet ou texte
#       
###########################################################################
from twisted.python import log
from ead2.backend.lib.action import * # import des actions et des types
from ead2.backend.actions.tools import get_request, make_js_link, make_form_link, format_form_result
from ead2.lib.error import MissingKey, MissingValue
from ead2.config.config import ip_locale 

used_templates = ['main']

class Extraction(Action):
    """ outils d'extraction """
    user_description = Dict(default={}, doc="description de l'éxécutant", keys=['ip', 'name', 'role'])
    name = 'scribe_extraction'
    libelle = "Extraction"
    category = "Outils"
    description = "Extraction Sconet ou texte"
    request = Dict(default={}, doc="arguments de la requete en cours cote frontend", 
                                keys=['server', 'action'])
    form_result = Dict(default={}, doc="Retour de formulaire en Json", keys=[])

    def execute(self):
        """ renvoie les données pour l'affichage 
            insertion de la page de l'ead 1
        """
        params, self.server_nb = get_request(self.request)
        result = {'titre':self.description}
        result['url'] = "https://%s:8501/extraction/extraction.php"%ip_locale
        return self.send_all(result, template='scribe_extraction', templates=used_templates)
