# -*- coding: UTF-8 -*-
"""configuration du backend ead
"""
from ead2 import backend
#from ead2.config.config import *
import os
from os.path import isdir

# internationalisation
I18N_DIR = os.path.abspath(os.path.join(os.path.dirname(backend.__file__), 'i18n'))
# nom de l'application
APP_NAME = "ead2"

# repertoire des actions
# ex : ROOT_DIR/ead2/backend/actions
ACTION_DIR = os.path.abspath(os.path.join(os.path.dirname(backend.__file__), 'actions'))
# repertoire des scripts lances par les actions
SCRIPT_DIR = os.path.abspath(os.path.join(os.path.dirname(backend.__file__), 'bin'))
# repertoire des fichiers telecharges par le frontend
from creole.fonctionseole import get_module_name
module = get_module_name()
DOWNLOAD_DIR = os.path.abspath(os.path.join(os.path.join(os.path.dirname(backend.__file__), 'download'),module))
MD5_DIR = os.path.abspath(os.path.join('/tmp/', 'md5'))
# fichier de configuration (ce repertoire)
CONFIG_DIR = os.path.abspath(os.path.dirname(__file__))

# repertoire des gabarits disponibles pour envoir par le backend
# exemple : ROOT_DIR/ead2/backend/template
TEMPLATE_DIR = os.path.normpath(os.path.abspath(
    os.path.join(os.path.dirname(__file__), '..', 'template')))

#UID de l'utilisateur nobody
NOBODY_UID = 65534
#GID de l'utilisateur nobody
NOBODY_GID = 65534
# Le port des agents zephir on teste qu'ils sont la ....
try:
    from zephir.monitor.agentmanager import config
    AGENT_PORT = 8090
except:
    AGENT_PORT = None
protocol = {'zephir':'https'}
if protocol.has_key(module):
    AGENT_PROTOCOL = protocol[module]
else:
    AGENT_PROTOCOL = 'http'
#fichier de login/password local encrypte
PASSWD_FILE = os.path.join(CONFIG_DIR, 'passwd.ini')
#fichier des cles associees a chaque frontend
FRONTEND_KEYS_FILE = os.path.join(CONFIG_DIR, 'frontend_keys.ini')
#chemin vers les fichiers de commande bacula
BACULA_DIR = "/usr/share/eole/bacula/"
#chemin vers les fichiers temporaires bacula de l'ead
BACULA_TEMP_DIR = "/var/www/ead/tmp/"
if module == 'horus':
    BACULA_CONFIG_DIR = "/var/www/ead/tmp/"
elif module == 'scribe':
    BACULA_CONFIG_DIR = "/var/www/ead/config/"
else:
    BACULA_CONFIG_DIR = ""
#chemin vers les fichiers temporaires
TEMP_DIR = os.path.abspath(os.path.join(os.path.dirname(backend.__file__), 'tmp'))
#chemin vers les fichiers temporaires pour les mises a jour de l'ead
MAJ_TEMP_DIR = TEMP_DIR
#chemin vers les fichiers d'aide
HELP_DIR = os.path.abspath(os.path.join(os.path.dirname(backend.__file__), 'aide'))
#chemin vers les fichiers de logs de l'ead1:
if isdir('/var/www/ead/tmp'):EAD_TEMP_DIR = "/var/www/ead/tmp/"
else:EAD_TEMP_DIR = "/tmp/"
