# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# liste des fichiers utilises par les actions du serveur de commande
#
# nomDuDico = nomDeAction
#
###########################################################################

from os.path import join
from ead2.backend.config.config import CONFIG_DIR, TEMP_DIR, MAJ_TEMP_DIR, BACULA_TEMP_DIR, BACULA_CONFIG_DIR, EAD_TEMP_DIR

# fichier de configuration pour la page de service simplifiee
simple_services="/usr/share/ead2/backend/config/simple_services.ini"

# fichier de configuration pour la gestion de profils
role_filename = "/usr/share/ead2/backend/config/roles_local.ini"
perm_filename = "/usr/share/ead2/backend/config/perm_local.ini"
ldapkeys_filename = "/usr/share/ead2/backend/config/ldapkeys.txt"

ajout_filtres = '/usr/share/eole/ajout_filtres.sh'
index = {'blacklist':'/var/www/ead/tmp/blacklist-date.txt'}

navigation_filters = { 'filtres_opt':'/etc/squid/filtres-opt',
                       'p2p_status':'/var/www/ead/tmp/kill-p2p',
                       'list_mime':join(CONFIG_DIR, 'mime_liste.txt'),
                       'signalement_msg':join(CONFIG_DIR, 'signalement_msg.txt')
                    }
journal_filename = join(TEMP_DIR, 'journal')
maj = {'maj':join(MAJ_TEMP_DIR, 'maj.txt'),
       'auto':join(MAJ_TEMP_DIR, 'cron.txt'),
       'rapport':join(EAD_TEMP_DIR, 'rapport-maj.html')#join(MAJ_TEMP_DIR, 'rapport-maj.txt')
      }
reconf = { 'log':join('/usr/share/ead2/backend/tmp', 'reconf.log'),
         }
bacula = {'distant':join(BACULA_CONFIG_DIR, 'bacula-distant.txt'),
            'usb':join(BACULA_CONFIG_DIR, 'bacula-usb.txt'),
            'rapport':join(BACULA_TEMP_DIR, 'rapport-bacula.txt'),
            'rapport_simple':'/var/www/ead/tmp/resultat-bacula'
        }
# fichier de config pour les reglages de securite
securite = {'regles':"/var/www/ead/tmp/regles.csv",
            'p2p':"/var/www/ead/tmp/kill-p2p",
            'horaire':"/var/www/ead/tmp/horaires.txt"
            }
# fichier de config du serveur de test de bande passante
bande_passante = {'server':join(TEMP_DIR, 'bp_server.txt'), 'record':join(TEMP_DIR, 'bp_record.txt')}
# rapport d'extraction
rapport_extraction = "/var/www/ead/extraction/tmp/rapport.txt"
liste_comptes = "/var/www/ead/extraction/tmp/info.csv"
# outil de recuperation des clients connectes au domaine samba
get_client_scribe_script = "/usr/share/eole/controlevnc/manage_stations.py"
## fichier pour la configuration d'assr
assr = {'conf_apache':'/etc/apache2/sites-enabled/80_assr.conf', 'dir':'/home/serveurassr/',
        'user_script':'/usr/share/eole/backend/assr_user_create.py', 'script': '/usr/share/ead/assr.sh',
        'rapport':'/var/www/ead/tmp/dl-assr.txt', 'url':'/var/www/ead/config/url_assr',
        'at':'/var/www/ead/config/at_assr', 'pass':'/var/www/ead/config/pass_assr', }
## script pour la gestion des imprimantes
printers_conf = {'script':"/usr/share/ead/printers.sh"}
# modification groupée de mot de passe
pwd_dir = {'rapport' : join(TEMP_DIR, 'passwords')}

# chemin vers la configuration du mode de controle de VNC
vnc={'conf_dir':"/var/www/ead/config/controle", 'script_path':"/usr/share/ead/gen-vncpasswd.py"}
