#-*- coding: utf-8 -*-
###########################################################################
## Eole NG - 2007  
## Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
## Licence CeCill  cf /root/LicenceEole.txt
## eole@ac-dijon.fr 
##  
## lanceur de l'ead-server
##  
############################################################################
from twisted.application import internet, service
from twisted.python import usage
from twisted.web import server, static, script
from nevow import appserver

from ead2.config.config import BACKEND_LISTEN_PORT, EADFILE_LISTEN_PORT
from ead2.lib.libsecure import ServerContextFactory
from ead2.backend.lib.eadserver import Amon

from ead2.backend.config.config import DOWNLOAD_DIR, MD5_DIR
from ead2.backend.lib.eadfile import EadFile

# initialisation des donnees pour le systeme de fichier
filesyst = EadFile()
filesyst.create_md5()

# creation de l'application
application = service.Application("eole_ead2")

# ceration du service
myService = service.IServiceCollection(application)

# creation de la connexion pour le backend
server2 = internet.SSLServer(BACKEND_LISTEN_PORT, server.Site(Amon()),ServerContextFactory())
server2.setServiceParent(myService)

# creation du serveur de fichier
root = static.File(DOWNLOAD_DIR)
root.putChild('md5', static.File('/tmp/md5/'))
site = server.Site(root)
internet.TCPServer(EADFILE_LISTEN_PORT, site).setServiceParent(myService)
